## telegram-desktop 4.14.9+ds

=== CMakeLists.txt ===
# This file is part of Telegram Desktop,
# the official desktop application for the Telegram messaging service.
#
# For license and copyright information please follow this link:
# https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL

if (APPLE)
    # target_precompile_headers with COMPILE_LANGUAGE restriction.
    cmake_minimum_required(VERSION 3.23)
else()
    cmake_minimum_required(VERSION 3.16)
endif()
if (POLICY CMP0149)
    cmake_policy(SET CMP0149 NEW)
endif()

set_property(GLOBAL PROPERTY USE_FOLDERS ON)

include(cmake/validate_special_target.cmake)
include(cmake/version.cmake)
desktop_app_parse_version(Telegram/build/version)

set(project_langs C CXX)
if (APPLE)
    list(APPEND project_langs OBJC OBJCXX)
elseif (LINUX)
    list(APPEND project_langs ASM)
endif()

project(Telegram
    LANGUAGES ${project_langs}
    VERSION ${desktop_app_version_cmake}
    DESCRIPTION "Official Telegram Desktop messenger"
    HOMEPAGE_URL "https://desktop.telegram.org"
)
set_property(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} PROPERTY VS_STARTUP_PROJECT Telegram)

get_filename_component(third_party_loc "Telegram/ThirdParty" REALPATH)
get_filename_component(submodules_loc "Telegram" REALPATH)
get_filename_component(cmake_helpers_loc "cmake" REALPATH)

if (NOT DESKTOP_APP_USE_PACKAGED AND WIN32)
    set(Python3_EXECUTABLE ${CMAKE_CURRENT_SOURCE_DIR}/../ThirdParty/python/Scripts/python)
endif()

include(cmake/variables.cmake)
include(cmake/nice_target_sources.cmake)
include(cmake/target_compile_options_if_exists.cmake)
include(cmake/target_link_frameworks.cmake)
include(cmake/target_link_optional_libraries.cmake)
include(cmake/target_link_options_if_exists.cmake)
include(cmake/target_link_static_libraries.cmake)
include(cmake/init_target.cmake)
include(cmake/generate_target.cmake)
include(cmake/nuget.cmake)
include(cmake/validate_d3d_compiler.cmake)
include(cmake/target_prepare_qrc.cmake)

include(cmake/options.cmake)

if (NOT DESKTOP_APP_USE_PACKAGED)
    if (WIN32)
        set(qt_version 5.15.12)
    elseif (APPLE)
        set(qt_version 6.2.7)
    endif()
endif()
include(cmake/external/qt/package.cmake)

set(desktop_app_skip_libs
    variant
)

add_subdirectory(cmake)
add_subdirectory(Telegram)

=== Telegram/CMakeLists.txt ===
# This file is part of Telegram Desktop,
# the official desktop application for the Telegram messaging service.
#
# For license and copyright information please follow this link:
# https://github.com/telegramdesktop/tdesktop/blob/master/LEGAL

add_executable(Telegram WIN32 MACOSX_BUNDLE)
init_non_host_target(Telegram)

add_subdirectory(lib_rpl)
add_subdirectory(lib_crl)
add_subdirectory(lib_base)
add_subdirectory(lib_ui)
add_subdirectory(lib_tl)
add_subdirectory(lib_spellcheck)
add_subdirectory(lib_storage)
add_subdirectory(lib_lottie)
add_subdirectory(lib_qr)
add_subdirectory(lib_webrtc)
add_subdirectory(lib_webview)
add_subdirectory(codegen)

get_filename_component(src_loc SourceFiles REALPATH)
get_filename_component(res_loc Resources REALPATH)

include(cmake/telegram_options.cmake)
include(cmake/lib_ffmpeg.cmake)
include(cmake/lib_stripe.cmake)
include(cmake/lib_tgvoip.cmake)
include(cmake/lib_tgcalls.cmake)
include(cmake/lib_prisma.cmake)
include(cmake/td_export.cmake)
include(cmake/td_mtproto.cmake)
include(cmake/td_lang.cmake)
include(cmake/td_scheme.cmake)
include(cmake/td_ui.cmake)
include(cmake/generate_appdata_changelog.cmake)

if (WIN32)
    include(cmake/generate_midl.cmake)
    generate_midl(Telegram ${src_loc}
        platform/win/windows_quiethours.idl
        platform/win/windows_toastactivator.idl
    )

    nuget_add_winrt(Telegram)
endif()

set_target_properties(Telegram PROPERTIES AUTOMOC ON)

target_link_libraries(Telegram
PRIVATE
    tdesktop::lib_tgcalls_legacy
    tdesktop::lib_tgcalls
    tdesktop::lib_tgvoip

    # Order in this list defines the order of include paths in command line.
    # We need to place desktop-app::external_minizip this early to have its
    # include paths (usually ${PREFIX}/include/minizip) before any depend that
    # would add ${PREFIX}/include. This path may have a different <zip.h>,
    # for example installed by libzip (https://libzip.org).
    desktop-app::external_minizip

    tdesktop::td_export
    tdesktop::td_mtproto
    tdesktop::td_lang
    tdesktop::td_scheme
    tdesktop::td_ui
    desktop-app::lib_webrtc
    desktop-app::lib_base
    desktop-app::lib_crl
    desktop-app::lib_ui
    desktop-app::lib_tl
    desktop-app::lib_spellcheck
    desktop-app::lib_storage
    desktop-app::lib_lottie
    desktop-app::lib_qr
    desktop-app::lib_webview
    desktop-app::lib_ffmpeg
    desktop-app::lib_stripe
    desktop-app::external_rlottie
    desktop-app::external_zlib
    desktop-app::external_kcoreaddons
    desktop-app::external_qt_static_plugins
    desktop-app::external_qt
    desktop-app::external_qr_code_generator
    desktop-app::external_crash_reports
    desktop-app::external_auto_updates
    desktop-app::external_openssl
    desktop-app::external_openal
    desktop-app::external_xxhash
)

target_precompile_headers(Telegram PRIVATE $<$<COMPILE_LANGUAGE:CXX,OBJCXX>:${src_loc}/stdafx.h>)
nice_target_sources(Telegram ${src_loc}
PRIVATE
    ${style_files}

    api/api_attached_stickers.cpp
    api/api_attached_stickers.h
    api/api_authorizations.cpp
    api/api_authorizations.h
    api/api_blocked_peers.cpp
    api/api_blocked_peers.h
    api/api_bot.cpp
    api/api_bot.h
    api/api_chat_filters.cpp
    api/api_chat_filters.h
    api/api_chat_invite.cpp
    api/api_chat_invite.h
    api/api_chat_participants.cpp
    api/api_chat_participants.h
    api/api_cloud_password.cpp
    api/api_cloud_password.h
    api/api_common.cpp
    api/api_common.h
    api/api_confirm_phone.cpp
    api/api_confirm_phone.h
    api/api_editing.cpp
    api/api_editing.h
    api/api_global_privacy.cpp
    api/api_global_privacy.h
    api/api_hash.cpp
    api/api_hash.h
    api/api_invite_links.cpp
    api/api_invite_links.h
    api/api_media.cpp
    api/api_media.h
    api/api_messages_search.cpp
    api/api_messages_search.h
    api/api_messages_search_merged.cpp
    api/api_messages_search_merged.h
    api/api_peer_colors.cpp
    api/api_peer_colors.h
    api/api_peer_photo.cpp
    api/api_peer_photo.h
    api/api_polls.cpp
    api/api_polls.h
    api/api_premium.cpp
    api/api_premium.h
    api/api_premium_option.cpp
    api/api_premium_option.h
    api/api_report.cpp
    api/api_report.h
    api/api_ringtones.cpp
    api/api_ringtones.h
    api/api_self_destruct.cpp
    api/api_self_destruct.h
    api/api_send_progress.cpp
    api/api_send_progress.h
    api/api_sending.cpp
    api/api_sending.h
    api/api_sensitive_content.cpp
    api/api_sensitive_content.h
    api/api_single_message_search.cpp
    api/api_single_message_search.h
    api/api_statistics.cpp
    api/api_statistics.h
    api/api_text_entities.cpp
    api/api_text_entities.h
    api/api_toggling_media.cpp
    api/api_toggling_media.h
    api/api_transcribes.cpp
    api/api_transcribes.h
    api/api_unread_things.cpp
    api/api_unread_things.h
    api/api_updates.cpp
    api/api_updates.h
    api/api_user_names.cpp
    api/api_user_names.h
    api/api_user_privacy.cpp
    api/api_user_privacy.h
    api/api_views.cpp
    api/api_views.h
    api/api_websites.cpp
    api/api_websites.h
    api/api_who_reacted.cpp
    api/api_who_reacted.h
    boxes/filters/edit_filter_box.cpp
    boxes/filters/edit_filter_box.h
    boxes/filters/edit_filter_chats_list.cpp
    boxes/filters/edit_filter_chats_list.h
    boxes/filters/edit_filter_links.cpp
    boxes/filters/edit_filter_links.h
    boxes/peers/add_bot_to_chat_box.cpp
    boxes/peers/add_bot_to_chat_box.h
    boxes/peers/add_participants_box.cpp
    boxes/peers/add_participants_box.h
    boxes/peers/choose_peer_box.cpp
    boxes/peers/choose_peer_box.h
    boxes/peers/edit_contact_box.cpp
    boxes/peers/edit_contact_box.h
    boxes/peers/edit_forum_topic_box.cpp
    boxes/peers/edit_forum_topic_box.h
    boxes/peers/edit_linked_chat_box.cpp
    boxes/peers/edit_linked_chat_box.h
    boxes/peers/edit_members_visible.cpp
    boxes/peers/edit_members_visible.h
    boxes/peers/edit_participant_box.cpp
    boxes/peers/edit_participant_box.h
    boxes/peers/edit_participants_box.cpp
    boxes/peers/edit_participants_box.h
    boxes/peers/edit_peer_color_box.cpp
    boxes/peers/edit_peer_color_box.h
    boxes/peers/edit_peer_common.h
    boxes/peers/edit_peer_info_box.cpp
    boxes/peers/edit_peer_info_box.h
    boxes/peers/edit_peer_invite_link.cpp
    boxes/peers/edit_peer_invite_link.h
    boxes/peers/edit_peer_invite_links.cpp
    boxes/peers/edit_peer_invite_links.h
    boxes/peers/edit_peer_permissions_box.cpp
    boxes/peers/edit_peer_permissions_box.h
    boxes/peers/edit_peer_reactions.cpp
    boxes/peers/edit_peer_reactions.h
    boxes/peers/edit_peer_requests_box.cpp
    boxes/peers/edit_peer_requests_box.h
    boxes/peers/edit_peer_type_box.cpp
    boxes/peers/edit_peer_type_box.h
    boxes/peers/edit_peer_usernames_list.cpp
    boxes/peers/edit_peer_usernames_list.h
    boxes/peers/peer_short_info_box.cpp
    boxes/peers/peer_short_info_box.h
    boxes/peers/prepare_short_info_box.cpp
    boxes/peers/prepare_short_info_box.h
    boxes/peers/replace_boost_box.cpp
    boxes/peers/replace_boost_box.h
    boxes/about_box.cpp
    boxes/about_box.h
    boxes/about_sponsored_box.cpp
    boxes/about_sponsored_box.h
    boxes/abstract_box.cpp
    boxes/abstract_box.h
    boxes/add_contact_box.cpp
    boxes/add_contact_box.h
    boxes/auto_lock_box.cpp
    boxes/auto_lock_box.h
    boxes/auto_download_box.cpp
    boxes/auto_download_box.h
    boxes/background_box.cpp
    boxes/background_box.h
    boxes/background_preview_box.cpp
    boxes/background_preview_box.h
    boxes/choose_filter_box.cpp
    boxes/choose_filter_box.h
    boxes/connection_box.cpp
    boxes/connection_box.h
    boxes/create_poll_box.cpp
    boxes/create_poll_box.h
    boxes/delete_messages_box.cpp
    boxes/delete_messages_box.h
    boxes/dictionaries_manager.cpp
    boxes/dictionaries_manager.h
    boxes/download_path_box.cpp
    boxes/download_path_box.h
    boxes/edit_caption_box.cpp
    boxes/edit_caption_box.h
    boxes/edit_privacy_box.cpp
    boxes/edit_privacy_box.h
    boxes/gift_premium_box.cpp
    boxes/gift_premium_box.h
    boxes/language_box.cpp
    boxes/language_box.h
    boxes/local_storage_box.cpp
    boxes/local_storage_box.h
    boxes/max_invite_box.cpp
    boxes/max_invite_box.h
    boxes/peer_list_box.cpp
    boxes/peer_list_box.h
    boxes/peer_list_controllers.cpp
    boxes/peer_list_controllers.h
    boxes/peer_lists_box.cpp
    boxes/peer_lists_box.h
    boxes/passcode_box.cpp
    boxes/passcode_box.h
    boxes/phone_banned_box.cpp
    boxes/phone_banned_box.h
    boxes/pin_messages_box.cpp
    boxes/pin_messages_box.h
    boxes/premium_limits_box.cpp
    boxes/premium_limits_box.h
    boxes/premium_preview_box.cpp
    boxes/premium_preview_box.h
    boxes/reactions_settings_box.cpp
    boxes/reactions_settings_box.h
    boxes/report_messages_box.cpp
    boxes/report_messages_box.h
    boxes/ringtones_box.cpp
    boxes/ringtones_box.h
    boxes/self_destruction_box.cpp
    boxes/self_destruction_box.h
    boxes/send_files_box.cpp
    boxes/send_files_box.h
    boxes/sessions_box.cpp
    boxes/sessions_box.h
    boxes/share_box.cpp
    boxes/share_box.h
    boxes/sticker_set_box.cpp
    boxes/sticker_set_box.h
    boxes/stickers_box.cpp
    boxes/stickers_box.h
    boxes/translate_box.cpp
    boxes/translate_box.h
    boxes/url_auth_box.cpp
    boxes/url_auth_box.h
    boxes/username_box.cpp
    boxes/username_box.h
    calls/group/calls_choose_join_as.cpp
    calls/group/calls_choose_join_as.h
    calls/group/calls_cover_item.cpp
    calls/group/calls_cover_item.h
    calls/group/calls_group_call.cpp
    calls/group/calls_group_call.h
    calls/group/calls_group_common.cpp
    calls/group/calls_group_common.h
    calls/group/calls_group_invite_controller.cpp
    calls/group/calls_group_invite_controller.h
    calls/group/calls_group_members.cpp
    calls/group/calls_group_members.h
    calls/group/calls_group_members_row.cpp
    calls/group/calls_group_members_row.h
    calls/group/calls_group_menu.cpp
    calls/group/calls_group_menu.h
    calls/group/calls_group_panel.cpp
    calls/group/calls_group_panel.h
    calls/group/calls_group_rtmp.cpp
    calls/group/calls_group_rtmp.h
    calls/group/calls_group_settings.cpp
    calls/group/calls_group_settings.h
    calls/group/calls_group_toasts.cpp
    calls/group/calls_group_toasts.h
    calls/group/calls_group_viewport.cpp
    calls/group/calls_group_viewport.h
    calls/group/calls_group_viewport_opengl.cpp
    calls/group/calls_group_viewport_opengl.h
    calls/group/calls_group_viewport_raster.cpp
    calls/group/calls_group_viewport_raster.h
    calls/group/calls_group_viewport_tile.cpp
    calls/group/calls_group_viewport_tile.h
    calls/group/calls_volume_item.cpp
    calls/group/calls_volume_item.h
    calls/calls_box_controller.cpp
    calls/calls_box_controller.h
    calls/calls_call.cpp
    calls/calls_call.h
    calls/calls_emoji_fingerprint.cpp
    calls/calls_emoji_fingerprint.h
    calls/calls_instance.cpp
    calls/calls_instance.h
    calls/calls_panel.cpp
    calls/calls_panel.h
    calls/calls_signal_bars.cpp
    calls/calls_signal_bars.h
    calls/calls_top_bar.cpp
    calls/calls_top_bar.h
    calls/calls_userpic.cpp
    calls/calls_userpic.h
    calls/calls_video_bubble.cpp
    calls/calls_video_bubble.h
    calls/calls_video_incoming.cpp
    calls/calls_video_incoming.h
    chat_helpers/compose/compose_features.h
    chat_helpers/compose/compose_show.cpp
    chat_helpers/compose/compose_show.h
    chat_helpers/bot_command.cpp
    chat_helpers/bot_command.h
    chat_helpers/bot_keyboard.cpp
    chat_helpers/bot_keyboard.h
    chat_helpers/emoji_interactions.cpp
    chat_helpers/emoji_interactions.h
    chat_helpers/emoji_keywords.cpp
    chat_helpers/emoji_keywords.h
    chat_helpers/emoji_list_widget.cpp
    chat_helpers/emoji_list_widget.h
    chat_helpers/emoji_sets_manager.cpp
    chat_helpers/emoji_sets_manager.h

=== cmake/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_subdirectory(external)
if (DESKTOP_APP_USE_ALLOCATION_TRACER)
    add_subdirectory(linux_allocation_tracer)
endif()
if (WIN32)
    add_subdirectory(win_directx_helper)
endif()

=== Telegram/lib_base/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_base STATIC)
add_library(desktop-app::lib_base ALIAS lib_base)
init_target(lib_base)

add_library(lib_base_crash_report_writer STATIC)
add_library(desktop-app::lib_base_crash_report_writer ALIAS lib_base_crash_report_writer)
init_target(lib_base_crash_report_writer)

get_filename_component(src_loc . REALPATH)

target_precompile_headers(lib_base PRIVATE $<$<COMPILE_LANGUAGE:CXX,OBJCXX>:${src_loc}/base/base_pch.h>)
nice_target_sources(lib_base ${src_loc}
PRIVATE
    base/platform/linux/base_battery_saving_linux.cpp
    base/platform/linux/base_battery_saving_linux.h
    base/platform/linux/base_file_utilities_linux.cpp
    base/platform/linux/base_file_utilities_linux.h
    base/platform/linux/base_global_shortcuts_linux.cpp
    base/platform/linux/base_global_shortcuts_linux.h
    base/platform/linux/base_info_linux.cpp
    base/platform/linux/base_info_linux.h
    base/platform/linux/base_last_input_linux.cpp
    base/platform/linux/base_last_input_linux.h
    base/platform/linux/base_layout_switch_linux.cpp
    base/platform/linux/base_layout_switch_linux.h
    base/platform/linux/base_linux_allocation_tracer.cpp
    base/platform/linux/base_linux_allocation_tracer.h
    base/platform/linux/base_linux_dbus_utilities.cpp
    base/platform/linux/base_linux_dbus_utilities.h
    base/platform/linux/base_linux_library.cpp
    base/platform/linux/base_linux_library.h
    base/platform/linux/base_linux_wayland_integration.cpp
    base/platform/linux/base_linux_wayland_integration_dummy.cpp
    base/platform/linux/base_linux_wayland_integration.h
    base/platform/linux/base_linux_wayland_utilities.h
    base/platform/linux/base_linux_xcb_utilities.cpp
    base/platform/linux/base_linux_xcb_utilities.h
    base/platform/linux/base_linux_xdg_activation_token.cpp
    base/platform/linux/base_linux_xdg_activation_token.h
    base/platform/linux/base_linux_xdp_utilities.cpp
    base/platform/linux/base_linux_xdp_utilities.h
    base/platform/linux/base_linux_xsettings.cpp
    base/platform/linux/base_linux_xsettings.h
    base/platform/linux/base_network_reachability_linux.cpp
    base/platform/linux/base_power_save_blocker_linux.cpp
    base/platform/linux/base_power_save_blocker_linux.h
    base/platform/linux/base_process_linux.cpp
    base/platform/linux/base_process_linux.h
    base/platform/linux/base_system_media_controls_linux.cpp
    base/platform/linux/base_url_scheme_linux.cpp
    base/platform/linux/base_url_scheme_linux.h
    base/platform/mac/base_battery_saving_mac.mm
    base/platform/mac/base_battery_saving_mac.h
    base/platform/mac/base_confirm_quit.h
    base/platform/mac/base_confirm_quit.mm
    base/platform/mac/base_custom_app_icon_mac.h
    base/platform/mac/base_custom_app_icon_mac.mm
    base/platform/mac/base_file_utilities_mac.h
    base/platform/mac/base_file_utilities_mac.mm
    base/platform/mac/base_global_shortcuts_mac.mm
    base/platform/mac/base_global_shortcuts_mac.h
    base/platform/mac/base_info_mac.h
    base/platform/mac/base_info_mac.mm
    base/platform/mac/base_last_input_mac.h
    base/platform/mac/base_last_input_mac.mm
    base/platform/mac/base_layout_switch_mac.h
    base/platform/mac/base_layout_switch_mac.mm
    base/platform/mac/base_network_reachability_mac.mm
    base/platform/mac/base_power_save_blocker_mac.h
    base/platform/mac/base_power_save_blocker_mac.mm
    base/platform/mac/base_process_mac.h
    base/platform/mac/base_process_mac.mm
    base/platform/mac/base_system_media_controls_mac.mm
    base/platform/mac/base_url_scheme_mac.h
    base/platform/mac/base_url_scheme_mac.mm
    base/platform/mac/base_utilities_mac.h
    base/platform/mac/base_utilities_mac.mm
    base/platform/win/base_battery_saving_win.cpp
    base/platform/win/base_battery_saving_win.h
    base/platform/win/base_file_utilities_win.cpp
    base/platform/win/base_file_utilities_win.h
    base/platform/win/base_global_shortcuts_win.cpp
    base/platform/win/base_global_shortcuts_win.h
    base/platform/win/base_info_win.cpp
    base/platform/win/base_info_win.h
    base/platform/win/base_last_input_win.cpp
    base/platform/win/base_last_input_win.h
    base/platform/win/base_layout_switch_win.cpp
    base/platform/win/base_layout_switch_win.h
    base/platform/win/base_network_reachability_win.cpp
    base/platform/win/base_power_save_blocker_win.cpp
    base/platform/win/base_power_save_blocker_win.h
    base/platform/win/base_process_win.cpp
    base/platform/win/base_process_win.h
    base/platform/win/base_system_media_controls_win.cpp
    base/platform/win/base_url_scheme_win.cpp
    base/platform/win/base_url_scheme_win.h
    base/platform/win/base_windows_co_task_mem.h
    base/platform/win/base_windows_gdiplus_h.h
    base/platform/win/base_windows_rpcndr_h.h
    base/platform/win/base_windows_safe_library.cpp
    base/platform/win/base_windows_safe_library.h
    base/platform/win/base_windows_shlobj_h.h
    base/platform/win/base_windows_winrt.cpp
    base/platform/win/base_windows_winrt.h
    base/platform/win/base_windows_wrl.cpp
    base/platform/win/base_windows_wrl.h
    base/platform/win/wrl/wrl_implements_h.h
    base/platform/win/wrl/wrl_module_h.h
    base/platform/base_platform_custom_app_icon.h
    base/platform/base_platform_global_shortcuts.h
    base/platform/base_platform_info.cpp
    base/platform/base_platform_info.h
    base/platform/base_platform_last_input.h
    base/platform/base_platform_layout_switch.h
    base/platform/base_platform_network_reachability.h
    base/platform/base_platform_file_utilities.h
    base/platform/base_platform_power_save_blocker.h
    base/platform/base_platform_process.h
    base/platform/base_platform_url_scheme.h
    base/platform/base_platform_system_media_controls.h
    base/algorithm.cpp
    base/algorithm.h
    base/assertion.cpp
    base/assertion.h
    base/atomic.h
    base/base_file_utilities.cpp
    base/base_file_utilities.h
    base/basic_types.h
    base/battery_saving.cpp
    base/battery_saving.h
    base/binary_guard.h
    base/build_config.h
    base/bytes.cpp
    base/bytes.h
    base/call_delayed.cpp
    base/call_delayed.h
    base/crc32hash.cpp
    base/crc32hash.h
    base/concurrent_timer.cpp
    base/concurrent_timer.h
    base/const_string.h
    base/custom_app_icon.h
    base/custom_delete.h
    base/debug_log.cpp
    base/debug_log.h
    base/enum_mask.h
    base/event_filter.cpp
    base/event_filter.h
    base/expected.h
    base/file_lock.h
    base/file_lock_win.cpp
    base/file_lock_posix.cpp
    base/flags.h
    base/flat_map.h
    base/flat_set.h
    base/functors.h
    base/global_shortcuts.h
    base/global_shortcuts_generic.cpp
    base/global_shortcuts_generic.h
    base/index_based_iterator.h
    base/integration.cpp
    base/integration.h
    base/invoke_queued.h
    base/last_used_cache.h
    base/last_user_input.cpp
    base/last_user_input.h
    base/match_method.h
    base/network_reachability.cpp
    base/network_reachability.h
    base/never_freed_pointer.h
    base/object_ptr.h
    base/ordered_set.h
    base/openssl_help.h
    base/optional.h
    base/options.cpp
    base/options.h
    base/overload.h
    base/parse_helper.cpp
    base/parse_helper.h
    base/power_save_blocker.cpp
    base/power_save_blocker.h
    base/qthelp_regex.h
    base/qthelp_url.cpp
    base/qthelp_url.h
    base/qt_connection.h
    base/qt_signal_producer.h
    base/random.cpp
    base/random.h
    base/required.h
    base/runtime_composer.cpp
    base/runtime_composer.h
    base/single_instance.cpp
    base/single_instance.h
    base/thread_safe_wrap.h
    base/timer.cpp
    base/timer.h
    base/timer_rpl.h
    base/type_traits.h
    base/unique_any.h
    base/unique_function.h
    base/unique_qptr.h
    base/unixtime.cpp
    base/unixtime.h
    base/variant.h
    base/virtual_method.h
    base/weak_ptr.h
    base/zlib_help.h
    base/qt/qt_common_adapters.h
    base/qt/qt_compare.h
    base/qt/qt_key_modifiers.h
    base/qt/qt_string_view.h
    base/qt/qt_tab_key.cpp
    base/qt/qt_tab_key.h

    base/base_pch.h
)

if (DESKTOP_APP_DISABLE_X11_INTEGRATION)
    remove_target_sources(lib_base ${src_loc}
        base/platform/linux/base_linux_xcb_utilities.cpp
        base/platform/linux/base_linux_xcb_utilities.h
        base/platform/linux/base_linux_xsettings.cpp
        base/platform/linux/base_linux_xsettings.h
    )
endif()

if (DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
    remove_target_sources(lib_base ${src_loc}
        base/platform/linux/base_linux_wayland_integration.cpp
        base/platform/linux/base_linux_wayland_utilities.h
    )
else()
    remove_target_sources(lib_base ${src_loc}
        base/platform/linux/base_linux_wayland_integration_dummy.cpp
    )
endif()

target_include_directories(lib_base
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_base
PUBLIC
    desktop-app::lib_rpl
    desktop-app::lib_crl
    desktop-app::external_qt
    desktop-app::external_openssl
    desktop-app::external_crash_reports
    desktop-app::external_ranges
    desktop-app::external_gsl
    desktop-app::external_expected
PRIVATE
    desktop-app::external_xxhash
)

if (WIN32)
    nuget_add_winrt(lib_base)
elseif (LINUX)
    target_link_libraries(lib_base
    PUBLIC
        desktop-app::external_glibmm
        desktop-app::external_kcoreaddons
    )

    include(${cmake_helpers_loc}/external/glib/generate_dbus.cmake)
    generate_dbus(lib_base org.mpris. Mpris ${src_loc}/base/platform/linux/mpris.xml)

    if (NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
        target_link_libraries(lib_base
        PUBLIC
            desktop-app::external_xcb_keysyms
            desktop-app::external_xcb_record
            desktop-app::external_xcb_screensaver
            desktop-app::external_xcb
        )
    endif()

    if (NOT DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
        qt_generate_wayland_protocol_client_sources(lib_base
        FILES
            ${third_party_loc}/wayland/protocol/wayland.xml
            ${third_party_loc}/wayland-protocols/unstable/idle-inhibit/idle-inhibit-unstable-v1.xml
        )

        target_link_libraries(lib_base
        PUBLIC
            desktop-app::external_wayland_client
        )
    endif()
endif()

if (DESKTOP_APP_USE_ALLOCATION_TRACER)
    target_compile_definitions(lib_base
    PRIVATE
        DESKTOP_APP_USE_ALLOCATION_TRACER
    )
endif()

#target_precompile_headers(lib_base_crash_report_writer REUSE_FROM lib_base)
target_precompile_headers(lib_base_crash_report_writer PRIVATE ${src_loc}/base/base_pch.h)
nice_target_sources(lib_base_crash_report_writer ${src_loc}
PRIVATE
    base/crash_report_header.cpp
    base/crash_report_header.h
    base/crash_report_writer.cpp
    base/crash_report_writer.h
)

if (DESKTOP_APP_DISABLE_CRASH_REPORTS)
    remove_target_sources(lib_base_crash_report_writer ${src_loc}
        base/crash_report_writer.cpp
        base/crash_report_writer.h
    )
endif()

target_link_libraries(lib_base_crash_report_writer PUBLIC desktop-app::lib_base)

=== Telegram/lib_lottie/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_lottie OBJECT)
add_library(desktop-app::lib_lottie ALIAS lib_lottie)
init_target(lib_lottie)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_lottie ${src_loc}
PRIVATE
    lottie/details/lottie_frame_provider.h
    lottie/details/lottie_frame_provider_direct.cpp
    lottie/details/lottie_frame_provider_direct.h
    lottie/details/lottie_frame_provider_shared.cpp
    lottie/details/lottie_frame_provider_shared.h
    lottie/details/lottie_frame_renderer.cpp
    lottie/details/lottie_frame_renderer.h
    lottie/lottie_animation.cpp
    lottie/lottie_animation.h
    lottie/lottie_common.cpp
    lottie/lottie_common.h
    lottie/lottie_frame_generator.cpp
    lottie/lottie_frame_generator.h
    lottie/lottie_multi_player.cpp
    lottie/lottie_multi_player.h
    lottie/lottie_player.h
    lottie/lottie_single_player.cpp
    lottie/lottie_single_player.h
    lottie/lottie_icon.cpp
    lottie/lottie_icon.h
)

if (DESKTOP_APP_LOTTIE_USE_CACHE)
    nice_target_sources(lib_lottie ${src_loc}
    PRIVATE
        lottie/details/lottie_cache.cpp
        lottie/details/lottie_cache.h
        lottie/details/lottie_cache_frame_storage.cpp
        lottie/details/lottie_cache_frame_storage.h
        lottie/details/lottie_frame_provider_cached.cpp
        lottie/details/lottie_frame_provider_cached.h
        lottie/details/lottie_frame_provider_cached_multi.cpp
        lottie/details/lottie_frame_provider_cached_multi.h
    )
    target_compile_definitions(lib_lottie PRIVATE LOTTIE_USE_CACHE)
    target_link_libraries(lib_lottie
    PRIVATE
        desktop-app::lib_ffmpeg
        desktop-app::external_lz4
    )
endif()

if (DESKTOP_APP_USE_PACKAGED_RLOTTIE)
    target_compile_definitions(lib_lottie PRIVATE LOTTIE_USE_PACKAGED_RLOTTIE)
endif()

target_include_directories(lib_lottie
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_lottie
PUBLIC
    desktop-app::lib_ui
PRIVATE
    desktop-app::external_rlottie
)

=== Telegram/lib_rpl/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_rpl INTERFACE)
add_library(desktop-app::lib_rpl ALIAS lib_rpl)

get_filename_component(src_loc "." REALPATH)

nice_target_sources(lib_rpl ${src_loc}
INTERFACE
    rpl/details/callable.h
    rpl/details/superset_type.h
    rpl/details/type_list.h
    rpl/after_next.h
    rpl/before_next.h
    rpl/combine.h
    rpl/combine_previous.h
    rpl/complete.h
    rpl/conditional.h
    rpl/consumer.h
    rpl/deferred.h
    rpl/distinct_until_changed.h
    rpl/event_stream.h
    rpl/fail.h
    rpl/filter.h
    rpl/flatten_latest.h
    rpl/lifetime.h
    rpl/map.h
    rpl/mappers.h
    rpl/merge.h
    rpl/never.h
    rpl/producer.h
    rpl/range.h
    rpl/rpl.h
    rpl/skip.h
    rpl/take.h
    rpl/then.h
    rpl/type_erased.h
    rpl/variable.h
)

target_include_directories(lib_rpl
INTERFACE
    ${src_loc}
)

target_link_libraries(lib_rpl
INTERFACE
    desktop-app::external_gsl
)

=== Telegram/lib_spellcheck/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_spellcheck STATIC)
add_library(desktop-app::lib_spellcheck ALIAS lib_spellcheck)
init_target(lib_spellcheck)

get_filename_component(src_loc . REALPATH)

set(use_enchant 0)
if (LINUX AND DESKTOP_APP_USE_ENCHANT)
    set(use_enchant 1)
endif()

set(system_spellchecker 0)
if ((APPLE OR WIN32 OR use_enchant) AND NOT DESKTOP_APP_USE_HUNSPELL_ONLY)
    set(system_spellchecker 1)
endif()

if (APPLE)
    target_link_frameworks_weak(lib_spellcheck
    PUBLIC
        NaturalLanguage # Since macOS 10.14 only.
    )
endif()

set(use_cld3 0)
if (LINUX OR DESKTOP_APP_USE_CLD3)
    set(use_cld3 1)
endif()

target_precompile_headers(lib_spellcheck PRIVATE ${src_loc}/spellcheck/spellcheck_pch.h)
nice_target_sources(lib_spellcheck ${src_loc}
PRIVATE
    highlighting/highlighting.qrc

    spellcheck/platform/linux/language_linux.cpp
    spellcheck/platform/linux/language_linux.h
    spellcheck/platform/linux/linux_enchant.cpp
    spellcheck/platform/linux/linux_enchant.h
    spellcheck/platform/linux/spellcheck_linux.cpp
    spellcheck/platform/linux/spellcheck_linux.h
    spellcheck/platform/mac/language_mac.h
    spellcheck/platform/mac/language_mac.mm
    spellcheck/platform/mac/spellcheck_mac.h
    spellcheck/platform/mac/spellcheck_mac.mm
    spellcheck/platform/win/language_win.cpp
    spellcheck/platform/win/language_win.h
    spellcheck/platform/win/spellcheck_win.cpp
    spellcheck/platform/win/spellcheck_win.h
    spellcheck/platform/platform_language.h
    spellcheck/platform/platform_spellcheck.h
    spellcheck/third_party/language_cld3.cpp
    spellcheck/third_party/language_cld3.h
    spellcheck/third_party/hunspell_controller.cpp
    spellcheck/third_party/hunspell_controller.h
    spellcheck/third_party/spellcheck_hunspell.cpp
    spellcheck/third_party/spellcheck_hunspell.h
    spellcheck/spellcheck_types.h
    spellcheck/spellcheck_highlight_syntax.cpp
    spellcheck/spellcheck_highlight_syntax.h
    spellcheck/spellcheck_utils.cpp
    spellcheck/spellcheck_utils.h
    spellcheck/spellcheck_value.cpp
    spellcheck/spellcheck_value.h
    spellcheck/spelling_highlighter.cpp
    spellcheck/spelling_highlighter.h
    spellcheck/spelling_highlighter_helper.cpp
    spellcheck/spelling_highlighter_helper.h

    spellcheck/spellcheck_pch.h
)

target_prepare_qrc(lib_spellcheck)

if (system_spellchecker)
    remove_target_sources(lib_spellcheck ${src_loc}
        spellcheck/third_party/spellcheck_hunspell.cpp
        spellcheck/third_party/spellcheck_hunspell.h
    )
else()
    remove_target_sources(lib_spellcheck ${src_loc}
        spellcheck/platform/linux/linux_enchant.cpp
        spellcheck/platform/linux/linux_enchant.h
        spellcheck/platform/linux/spellcheck_linux.cpp
        spellcheck/platform/linux/spellcheck_linux.h
        spellcheck/platform/mac/spellcheck_mac.h
        spellcheck/platform/mac/spellcheck_mac.mm
        spellcheck/platform/win/spellcheck_win.cpp
        spellcheck/platform/win/spellcheck_win.h
    )
endif()

if (use_cld3)
    target_link_libraries(lib_spellcheck PRIVATE desktop-app::external_cld3)
    remove_target_sources(lib_spellcheck ${src_loc}
        spellcheck/platform/linux/language_linux.cpp
        spellcheck/platform/linux/language_linux.h
        spellcheck/platform/mac/language_mac.h
        spellcheck/platform/mac/language_mac.mm
        spellcheck/platform/win/language_win.cpp
        spellcheck/platform/win/language_win.h
    )
else()
    remove_target_sources(lib_spellcheck ${src_loc}
        spellcheck/third_party/language_cld3.cpp
        spellcheck/third_party/language_cld3.h
    )
endif()

# We should support both types of spellchecker for Windows.
if (WIN32 OR NOT system_spellchecker)
    target_link_libraries(lib_spellcheck PRIVATE desktop-app::external_hunspell)
else()
    remove_target_sources(lib_spellcheck ${src_loc}
        spellcheck/third_party/hunspell_controller.cpp
        spellcheck/third_party/hunspell_controller.h
    )
endif()

target_include_directories(lib_spellcheck
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_spellcheck
PRIVATE
    desktop-app::lib_ui
    desktop-app::lib_base
    desktop-app::lib_rpl
    desktop-app::lib_crl
    desktop-app::lib_prisma
    desktop-app::external_qt
    desktop-app::external_ranges
    desktop-app::external_gsl
    desktop-app::external_xxhash
)

if (LINUX AND use_enchant)
    find_package(PkgConfig REQUIRED)

    pkg_search_module(ENCHANT REQUIRED enchant-2 enchant)
    target_include_directories(lib_spellcheck SYSTEM PRIVATE ${ENCHANT_INCLUDE_DIRS})
endif()

=== Telegram/lib_ui/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_ui STATIC)
add_library(desktop-app::lib_ui ALIAS lib_ui)
init_target(lib_ui)

include(cmake/generate_palette.cmake)
include(cmake/generate_styles.cmake)
include(cmake/generate_emoji.cmake)

get_filename_component(src_loc . REALPATH)

set(style_files
    ui/basic.style
    ui/layers/layers.style
    ui/widgets/widgets.style
)

generate_palette(lib_ui ui/colors.palette)
generate_styles(lib_ui ${src_loc} "${style_files}" ui/colors.palette)
generate_emoji(lib_ui emoji.txt emoji_suggestions/emoji_autocomplete.json)

set_target_properties(lib_ui PROPERTIES AUTOMOC ON)

target_precompile_headers(lib_ui PRIVATE $<$<COMPILE_LANGUAGE:CXX,OBJCXX>:${src_loc}/ui/ui_pch.h>)
nice_target_sources(lib_ui ${src_loc}
PRIVATE
    ${style_files}
    ui/colors.palette
    emoji_suggestions/emoji_autocomplete.json

    fonts/fonts.qrc
    qt_conf/win.qrc

    ui/dpr/dpr_icon.cpp
    ui/dpr/dpr_icon.h
    ui/dpr/dpr_image.h
    ui/effects/animation_value.cpp
    ui/effects/animation_value.h
    ui/effects/animation_value_f.h
    ui/effects/animations.cpp
    ui/effects/animations.h
    ui/effects/cross_animation.cpp
    ui/effects/cross_animation.h
    ui/effects/cross_line.cpp
    ui/effects/cross_line.h
    ui/effects/fade_animation.cpp
    ui/effects/fade_animation.h
    ui/effects/frame_generator.cpp
    ui/effects/frame_generator.h
    ui/effects/gradient.cpp
    ui/effects/gradient.h
    ui/effects/numbers_animation.cpp
    ui/effects/numbers_animation.h
    ui/effects/panel_animation.cpp
    ui/effects/panel_animation.h
    ui/effects/path_shift_gradient.cpp
    ui/effects/path_shift_gradient.h
    ui/effects/radial_animation.cpp
    ui/effects/radial_animation.h
    ui/effects/ripple_animation.cpp
    ui/effects/ripple_animation.h
    ui/effects/round_area_with_shadow.cpp
    ui/effects/round_area_with_shadow.h
    ui/effects/show_animation.cpp
    ui/effects/show_animation.h
    ui/effects/slide_animation.cpp
    ui/effects/slide_animation.h
    ui/effects/spoiler_mess.cpp
    ui/effects/spoiler_mess.h
    ui/gl/gl_detection.cpp
    ui/gl/gl_detection.h
    ui/gl/gl_image.cpp
    ui/gl/gl_image.h
    ui/gl/gl_math.cpp
    ui/gl/gl_math.h
    ui/gl/gl_primitives.cpp
    ui/gl/gl_primitives.h
    ui/gl/gl_shader.cpp
    ui/gl/gl_shader.h
    ui/gl/gl_surface.cpp
    ui/gl/gl_surface.h
    ui/gl/gl_window.cpp
    ui/gl/gl_window.h
    ui/image/image_prepare.cpp
    ui/image/image_prepare.h
    ui/layers/box_content.cpp
    ui/layers/box_content.h
    ui/layers/box_layer_widget.cpp
    ui/layers/box_layer_widget.h
    ui/layers/generic_box.cpp
    ui/layers/generic_box.h
    ui/layers/layer_manager.cpp
    ui/layers/layer_manager.h
    ui/layers/layer_widget.cpp
    ui/layers/layer_widget.h
    ui/layers/show.cpp
    ui/layers/show.h
    ui/paint/arcs.cpp
    ui/paint/arcs.h
    ui/paint/blob.cpp
    ui/paint/blob.h
    ui/paint/blobs.cpp
    ui/paint/blobs.h
    ui/paint/blobs_linear.cpp
    ui/paint/blobs_linear.h
    ui/platform/linux/ui_window_linux.cpp
    ui/platform/linux/ui_window_linux.h
    ui/platform/linux/ui_window_title_linux.cpp
    ui/platform/linux/ui_window_title_linux.h
    ui/platform/linux/ui_utility_linux.cpp
    ui/platform/linux/ui_utility_linux.h
    ui/platform/mac/ui_window_mac.h
    ui/platform/mac/ui_window_mac.mm
    ui/platform/mac/ui_window_title_mac.h
    ui/platform/mac/ui_window_title_mac.mm
    ui/platform/mac/ui_utility_mac.h
    ui/platform/mac/ui_utility_mac.mm
    ui/platform/win/ui_window_shadow_win.cpp
    ui/platform/win/ui_window_shadow_win.h
    ui/platform/win/ui_window_title_win.cpp
    ui/platform/win/ui_window_title_win.h
    ui/platform/win/ui_window_win.cpp
    ui/platform/win/ui_window_win.h
    ui/platform/win/ui_windows_direct_manipulation.cpp
    ui/platform/win/ui_windows_direct_manipulation.h
    ui/platform/win/ui_utility_win.cpp
    ui/platform/win/ui_utility_win.h
    ui/platform/ui_platform_window_title.cpp
    ui/platform/ui_platform_window_title.h
    ui/platform/ui_platform_window.cpp
    ui/platform/ui_platform_window.h
    ui/platform/ui_platform_utility.h
    ui/style/style_core.cpp
    ui/style/style_core.h
    ui/style/style_core_color.cpp
    ui/style/style_core_color.h
    ui/style/style_core_custom_font.cpp
    ui/style/style_core_custom_font.h
    ui/style/style_core_direction.cpp
    ui/style/style_core_direction.h
    ui/style/style_core_font.cpp
    ui/style/style_core_font.h
    ui/style/style_core_icon.cpp
    ui/style/style_core_icon.h
    ui/style/style_core_palette.cpp
    ui/style/style_core_palette.h
    ui/style/style_core_scale.cpp
    ui/style/style_core_scale.h
    ui/style/style_core_types.cpp
    ui/style/style_core_types.h
    ui/style/style_palette_colorizer.cpp
    ui/style/style_palette_colorizer.h
    ui/text/custom_emoji_instance.cpp
    ui/text/custom_emoji_instance.h
    ui/text/text.cpp
    ui/text/text.h
    ui/text/text_block.cpp
    ui/text/text_block.h
    ui/text/text_custom_emoji.cpp
    ui/text/text_custom_emoji.h
    ui/text/text_entity.cpp
    ui/text/text_entity.h
    ui/text/text_extended_data.cpp
    ui/text/text_extended_data.h
    ui/text/text_isolated_emoji.h
    ui/text/text_parser.cpp
    ui/text/text_parser.h
    ui/text/text_renderer.cpp
    ui/text/text_renderer.h
    ui/text/text_utilities.cpp
    ui/text/text_utilities.h
    ui/text/text_variant.cpp
    ui/text/text_variant.h
    ui/toast/toast.cpp
    ui/toast/toast.h
    ui/toast/toast_manager.cpp
    ui/toast/toast_manager.h
    ui/toast/toast_widget.cpp
    ui/toast/toast_widget.h
    ui/widgets/box_content_divider.cpp
    ui/widgets/box_content_divider.h
    ui/widgets/buttons.cpp
    ui/widgets/buttons.h
    ui/widgets/call_button.cpp
    ui/widgets/call_button.h
    ui/widgets/checkbox.cpp
    ui/widgets/checkbox.h
    ui/widgets/dropdown_menu.cpp
    ui/widgets/dropdown_menu.h
    ui/widgets/icon_button_with_text.cpp
    ui/widgets/icon_button_with_text.h
    ui/widgets/inner_dropdown.cpp
    ui/widgets/inner_dropdown.h
    ui/widgets/fields/input_field.cpp
    ui/widgets/fields/input_field.h
    ui/widgets/fields/masked_input_field.cpp
    ui/widgets/fields/masked_input_field.h
    ui/widgets/fields/number_input.cpp
    ui/widgets/fields/number_input.h
    ui/widgets/fields/password_input.cpp
    ui/widgets/fields/password_input.h
    ui/widgets/fields/time_part_input.cpp
    ui/widgets/fields/time_part_input.h
    ui/widgets/labels.cpp
    ui/widgets/labels.h
    ui/widgets/menu/menu.cpp
    ui/widgets/menu/menu.h
    ui/widgets/menu/menu_action.cpp
    ui/widgets/menu/menu_action.h
    ui/widgets/menu/menu_add_action_callback.cpp
    ui/widgets/menu/menu_add_action_callback.h
    ui/widgets/menu/menu_add_action_callback_factory.cpp
    ui/widgets/menu/menu_add_action_callback_factory.h
    ui/widgets/menu/menu_common.cpp
    ui/widgets/menu/menu_common.h
    ui/widgets/menu/menu_item_base.cpp
    ui/widgets/menu/menu_item_base.h
    ui/widgets/menu/menu_multiline_action.cpp
    ui/widgets/menu/menu_multiline_action.h
    ui/widgets/menu/menu_separator.cpp
    ui/widgets/menu/menu_separator.h
    ui/widgets/menu/menu_toggle.cpp
    ui/widgets/menu/menu_toggle.h
    ui/widgets/elastic_scroll.cpp
    ui/widgets/elastic_scroll.h
    ui/widgets/popup_menu.cpp
    ui/widgets/popup_menu.h
    ui/widgets/rp_window.cpp
    ui/widgets/rp_window.h
    ui/widgets/separate_panel.cpp
    ui/widgets/separate_panel.h
    ui/widgets/scroll_area.cpp
    ui/widgets/scroll_area.h
    ui/widgets/side_bar_button.cpp
    ui/widgets/side_bar_button.h
    ui/widgets/shadow.cpp
    ui/widgets/shadow.h
    ui/widgets/time_input.cpp
    ui/widgets/time_input.h
    ui/widgets/tooltip.cpp
    ui/widgets/tooltip.h
    ui/wrap/fade_wrap.cpp
    ui/wrap/fade_wrap.h
    ui/wrap/follow_slide_wrap.cpp
    ui/wrap/follow_slide_wrap.h
    ui/wrap/padding_wrap.cpp
    ui/wrap/padding_wrap.h
    ui/wrap/slide_wrap.cpp
    ui/wrap/slide_wrap.h
    ui/wrap/table_layout.cpp
    ui/wrap/table_layout.h
    ui/wrap/vertical_layout.cpp
    ui/wrap/vertical_layout.h
    ui/wrap/vertical_layout_reorder.cpp
    ui/wrap/vertical_layout_reorder.h
    ui/wrap/wrap.h
    ui/abstract_button.cpp
    ui/abstract_button.h
    ui/animated_icon.cpp
    ui/animated_icon.h
    ui/basic_click_handlers.cpp
    ui/basic_click_handlers.h
    ui/cached_special_layer_shadow_corners.cpp
    ui/cached_special_layer_shadow_corners.h
    ui/click_handler.cpp
    ui/click_handler.h
    ui/delayed_activation.cpp
    ui/delayed_activation.h
    ui/dragging_scroll_manager.cpp
    ui/dragging_scroll_manager.h
    ui/emoji_config.cpp
    ui/emoji_config.h
    ui/focus_persister.h
    ui/inactive_press.cpp
    ui/inactive_press.h
    ui/integration.cpp
    ui/integration.h
    ui/main_queue_processor.cpp
    ui/main_queue_processor.h
    ui/painter.h
    ui/ph.cpp
    ui/ph.h
    ui/rect.h
    ui/rect_part.h
    ui/round_rect.cpp
    ui/round_rect.h
    ui/rp_widget.cpp
    ui/rp_widget.h
    ui/ui_utility.cpp
    ui/ui_utility.h

    ui/ui_pch.h

    emoji_suggestions/emoji_suggestions.cpp
    emoji_suggestions/emoji_suggestions.h
    emoji_suggestions/emoji_suggestions_helper.h
)

if (DESKTOP_APP_USE_PACKAGED_FONTS)
    target_compile_definitions(lib_ui PRIVATE LIB_UI_USE_PACKAGED_FONTS)
    remove_target_sources(lib_ui ${src_loc} fonts/fonts.qrc)
endif()

if (WIN32)
    nuget_add_winrt(lib_ui)
endif()

target_include_directories(lib_ui
PUBLIC
    ${src_loc}
    ${src_loc}/emoji_suggestions
)

target_link_libraries(lib_ui
PUBLIC
    desktop-app::lib_base
PRIVATE
    desktop-app::external_zlib
    desktop-app::external_jpeg
    desktop-app::external_lz4
    desktop-app::external_xxhash
)

target_prepare_qrc(lib_ui)

=== Telegram/lib_webview/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(lib_webview STATIC)
add_library(desktop-app::lib_webview ALIAS lib_webview)
init_target(lib_webview)

get_filename_component(src_loc . REALPATH)

nice_target_sources(lib_webview ${src_loc}
PRIVATE
    webview/webview_dialog.cpp
    webview/webview_dialog.h
    webview/webview_embed.cpp
    webview/webview_embed.h
    webview/webview_interface.h

    webview/platform/mac/webview_mac.h
    webview/platform/mac/webview_mac.mm

    webview/platform/linux/webview_linux.h
    webview/platform/linux/webview_linux.cpp
    webview/platform/linux/webview_linux_compositor.cpp
    webview/platform/linux/webview_linux_compositor.h
    webview/platform/linux/webview_linux_webkitgtk_dummy.cpp
    webview/platform/linux/webview_linux_webkitgtk_library.cpp
    webview/platform/linux/webview_linux_webkitgtk_library.h
    webview/platform/linux/webview_linux_webkitgtk.cpp
    webview/platform/linux/webview_linux_webkitgtk.h

    webview/platform/win/webview_win.cpp
    webview/platform/win/webview_win.h
    webview/platform/win/webview_windows_edge_chromium.cpp
    webview/platform/win/webview_windows_edge_chromium.h
    webview/platform/win/webview_windows_edge_html.cpp
    webview/platform/win/webview_windows_edge_html.h
)

target_include_directories(lib_webview
PUBLIC
    ${src_loc}
)

target_link_libraries(lib_webview
PUBLIC
    desktop-app::lib_ui
    desktop-app::lib_base
)

if (WIN32)
    nuget_add_webview(lib_webview)
    nuget_add_winrt(lib_webview)
elseif (LINUX)
    find_package(Qt${QT_VERSION_MAJOR} OPTIONAL_COMPONENTS Quick QuickWidgets WaylandCompositor)
    if (TARGET Qt::Quick AND TARGET Qt::QuickWidgets AND TARGET Qt::WaylandCompositor)
        remove_target_sources(lib_webview ${src_loc}
            webview/platform/linux/webview_linux_webkitgtk_dummy.cpp
        )

        include(${cmake_helpers_loc}/external/glib/generate_dbus.cmake)
        generate_dbus(lib_webview org.desktop_app.GtkIntegration.Webview. Webview ${src_loc}/webview/platform/linux/webview_linux_interface.xml)
    else()
        remove_target_sources(lib_webview ${src_loc}
            webview/platform/linux/webview_linux_compositor.cpp
            webview/platform/linux/webview_linux_compositor.h
            webview/platform/linux/webview_linux_webkitgtk_library.cpp
            webview/platform/linux/webview_linux_webkitgtk_library.h
            webview/platform/linux/webview_linux_webkitgtk.cpp
        )
    endif()
endif()

=== cmake/external/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

macro(add_checked_subdirectory name)
    if (NOT DEFINED desktop_app_skip_libs
        OR NOT ${name} IN_LIST desktop_app_skip_libs)
        add_subdirectory(${name})
    endif()
endmacro()

add_checked_subdirectory(angle)
add_checked_subdirectory(auto_updates)
add_checked_subdirectory(boost)
if (add_cld3_library)
    add_checked_subdirectory(cld3)
endif()
add_checked_subdirectory(crash_reports)
if (LINUX)
    add_checked_subdirectory(dispatch)
endif()
add_checked_subdirectory(expected)
if (LINUX AND TARGET Qt::DBus AND NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
    add_checked_subdirectory(fcitx5_qt)
endif()
add_checked_subdirectory(ffmpeg)
if (LINUX)
    add_checked_subdirectory(glib)
    add_checked_subdirectory(glibmm)
endif()
add_checked_subdirectory(gsl)
if (LINUX AND NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
    add_checked_subdirectory(hime_qt)
endif()
if (add_hunspell_library)
	add_checked_subdirectory(hunspell)
endif()
add_checked_subdirectory(iconv)
add_checked_subdirectory(jpeg)
add_checked_subdirectory(kcoreaddons)
add_checked_subdirectory(kimageformats)
add_checked_subdirectory(lz4)
add_checked_subdirectory(minizip)
if (LINUX)
    add_checked_subdirectory(nimf_qt5)
endif()
add_checked_subdirectory(openal)
add_checked_subdirectory(openssl)
add_checked_subdirectory(opus)
add_checked_subdirectory(qt)
add_checked_subdirectory(qr_code_generator)
add_checked_subdirectory(ranges)
add_checked_subdirectory(rlottie)
add_checked_subdirectory(rnnoise)
if (LINUX AND NOT DESKTOP_APP_DISABLE_SCUDO)
    add_checked_subdirectory(scudo)
endif()
add_checked_subdirectory(ton)
add_checked_subdirectory(variant)
add_checked_subdirectory(vpx)
if (LINUX AND NOT DESKTOP_APP_DISABLE_WAYLAND_INTEGRATION)
    add_checked_subdirectory(wayland_client)
endif()
add_checked_subdirectory(webrtc)
if (LINUX AND NOT DESKTOP_APP_DISABLE_X11_INTEGRATION)
    add_checked_subdirectory(xcb)
endif()
add_checked_subdirectory(xxhash)
add_checked_subdirectory(zlib)

=== cmake/external/cld3/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

add_library(external_cld3 INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_cld3 ALIAS external_cld3)

add_library(external_cld3_bundled STATIC)
init_target(external_cld3_bundled "(external)")

set(cld3_loc ${third_party_loc}/cld3)
set(cld3_src ${cld3_loc}/src)

set(gen_loc ${cld3_loc}/build/gen)
set(gen_dst ${gen_loc}/cld_3/protos)

if (DESKTOP_APP_USE_PACKAGED)
    find_package(Protobuf)
    if (NOT Protobuf_FOUND)
        find_package(protobuf REQUIRED CONFIG)
    endif()
    set(protoc_executable protobuf::protoc)
    set(protobuf_lib protobuf::libprotobuf-lite)
elseif (WIN32)
    set(build_loc ${libs_loc}/protobuf/build/$<IF:$<CONFIG:Debug>,Debug,Release>)
    set(protoc_executable ${build_loc}/protoc.exe)
    set(protobuf_lib ${build_loc}/libprotobuf-lite.lib)
else()
    set(protoc_executable ${libs_loc}/protobuf/build/protoc)
    set(protobuf_lib ${libs_loc}/protobuf/build/libprotobuf-lite.a)
    if (LINUX)
        target_compile_options(external_cld3_bundled PRIVATE -Wno-implicit-fallthrough)
    endif()
endif()
if (PROTOBUF_PROTOC_EXECUTABLE)
    set(protoc_executable ${PROTOBUF_PROTOC_EXECUTABLE})
endif()

include(generate_protobuf.cmake)

function(generate protobuf_name)
    generate_single_protobuf(
        external_cld3_bundled
        ${gen_dst}
        ${protobuf_name}
        ${protoc_executable})
endfunction()

generate(feature_extractor.proto)
generate(sentence.proto)
generate(task_spec.proto)

nice_target_sources(external_cld3_bundled ${cld3_src}
PRIVATE
    feature_extractor.proto
    sentence.proto
    task_spec.proto

    base.cc
    embedding_feature_extractor.cc
    embedding_network.cc
    feature_extractor.cc
    feature_extractor.h
    feature_types.cc
    fml_parser.cc
    language_identifier_features.cc
    lang_id_nn_params.cc
    nnet_language_identifier.cc
    registry.cc
    relevant_script_feature.cc
    sentence_features.cc
    task_context.cc
    task_context_params.cc
    unicodetext.cc
    utils.cc
    workspace.cc

    script_span/generated_entities.cc
    script_span/getonescriptspan.cc
    script_span/getonescriptspan.h
    script_span/utf8statetable.cc
    script_span/offsetmap.cc
    script_span/text_processing.cc
    script_span/text_processing.h
    script_span/fixunicodevalue.cc
)

target_include_directories(external_cld3_bundled
PUBLIC
    ${cld3_src}
    ${gen_loc}
)

if (NOT DESKTOP_APP_USE_PACKAGED)
    target_include_directories(external_cld3_bundled
    PUBLIC
        ${libs_loc}/protobuf/src
        ${libs_loc}/protobuf/third_party/abseil-cpp
    )
endif()

target_link_libraries(external_cld3_bundled
PRIVATE
    ${protobuf_lib}
)

target_link_libraries(external_cld3
INTERFACE
    external_cld3_bundled
)

=== cmake/external/dispatch/CMakeLists.txt ===
# This file is part of Desktop App Toolkit,
# a set of libraries for developing nice desktop applications.
#
# For license and copyright information please follow this link:
# https://github.com/desktop-app/legal/blob/master/LEGAL

set(dispatch_loc ${third_party_loc}/dispatch)
set(dispatch_prefix ${CMAKE_CURRENT_BINARY_DIR}/dispatch-prefix)
set(dispatch_binary_dir ${dispatch_prefix}/src/dispatch-build)

if (DESKTOP_APP_USE_PACKAGED)
    find_library(DESKTOP_APP_DISPATCH_LIBRARIES dispatch)
    find_path(DESKTOP_APP_DISPATCH_INCLUDE_DIRS dispatch/dispatch.h)
endif()

if (NOT DESKTOP_APP_DISPATCH_LIBRARIES OR NOT DESKTOP_APP_DISPATCH_INCLUDE_DIRS)
    if (NOT DESKTOP_APP_USE_PACKAGED OR DESKTOP_APP_SPECIAL_TARGET)
        set(dispatch_extra_args
            -DCMAKE_BUILD_TYPE=Release
            "-DCMAKE_C_FLAGS=-g -pipe -fPIC -fno-omit-frame-pointer -fstack-protector-all -fstack-clash-protection -fcf-protection -D_FORTIFY_SOURCE=3 -D_GLIBCXX_ASSERTIONS"
            "-DCMAKE_CXX_FLAGS=-g -pipe -fPIC -fno-omit-frame-pointer -fstack-protector-all -fstack-clash-protection -fcf-protection -D_FORTIFY_SOURCE=3 -D_GLIBCXX_ASSERTIONS"
        )
    elseif (DEFINED CMAKE_BUILD_TYPE)
        set(dispatch_extra_args
            -DCMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}
        )
    else()
        set(dispatch_extra_args)
    endif()
    execute_process(
        COMMAND ${CMAKE_COMMAND} ${dispatch_loc}
            -B ${dispatch_binary_dir}
            -GNinja
            -DCMAKE_C_COMPILER=clang
            -DCMAKE_CXX_COMPILER=clang++
            -DBUILD_SHARED_LIBS=OFF
            -DBUILD_TESTING=OFF
            ${dispatch_extra_args}
    )

    execute_process(
        COMMAND ${CMAKE_COMMAND} --build ${dispatch_binary_dir} --parallel
    )

    if (NOT EXISTS ${dispatch_binary_dir}/src/libdispatch.a)
        if (DESKTOP_APP_SPECIAL_TARGET)
            message(FATAL_ERROR "Dispatch build failed")
        else()
            return()
        endif()
    endif()
endif()

add_library(external_dispatch INTERFACE IMPORTED GLOBAL)
add_library(desktop-app::external_dispatch ALIAS external_dispatch)

if (DESKTOP_APP_USE_PACKAGED AND DESKTOP_APP_DISPATCH_LIBRARIES AND DESKTOP_APP_DISPATCH_INCLUDE_DIRS)
    target_include_directories(external_dispatch SYSTEM INTERFACE ${DESKTOP_APP_DISPATCH_INCLUDE_DIRS})
    target_link_libraries(external_dispatch INTERFACE ${DESKTOP_APP_DISPATCH_LIBRARIES})
    return()
endif()

add_library(external_dispatch_bundled STATIC IMPORTED)

set_target_properties(external_dispatch_bundled PROPERTIES
    IMPORTED_LOCATION "${dispatch_binary_dir}/src/libdispatch.a"
)

target_include_directories(external_dispatch_bundled SYSTEM
INTERFACE
    ${dispatch_loc}
)

target_link_libraries(external_dispatch_bundled
INTERFACE
    ${dispatch_binary_dir}/src/BlocksRuntime/libBlocksRuntime.a
)

target_link_libraries(external_dispatch
INTERFACE
    external_dispatch_bundled
)

=== debian/changelog ===
telegram-desktop (4.14.9+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix building with ffmpeg 6.1+ (Closes: #1072455).

 -- Andrey Rakhmatullin <wrar@debian.org>  Sun, 25 Aug 2024 18:49:49 +0500

telegram-desktop (4.14.9+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 21 Jan 2024 20:09:47 +0300

telegram-desktop (4.14.4+ds-1) unstable; urgency=medium

  * New upstream release.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sun, 14 Jan 2024 09:03:35 +0300

telegram-desktop (4.14.3+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update patches.
    - 2015-System-wide-cppgir.patch
    - 2021-Remove-BYPRODUCTS.patch
  * Require the latest version of cppgir, 2.0 with fixes applied.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 08 Jan 2024 11:55:01 +0300

telegram-desktop (4.13.1+ds-1) unstable; urgency=medium

  * New upstream release.
  * Update patches to the newer upstream code.
  * New 2021-Remove-BYPRODUCTS.patch (Closes: #1058512)

 -- Nicholas Guriev <guriev-ns@ya.ru>  Fri, 29 Dec 2023 00:33:25 +0300

telegram-desktop (4.11.8+ds-1) unstable; urgency=medium

  [ Nicholas Guriev ]
  * New upstream bugfixing release.

  [ Samuel Thibault ]
  * Add hurd-amd64 case in the debian/control file.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Mon, 20 Nov 2023 10:22:05 +0300

telegram-desktop (4.11.5+ds-1) unstable; urgency=medium

  * New upstream release.
  * New patches:
    - 2019-Generate-libprisma-grammars.patch
    - 2020-Missing-variant-include.patch
  * New build dependencies, Node.js, Prism, Lodash, and Boost.Regex.

 -- Nicholas Guriev <guriev-ns@ya.ru>  Wed, 08 Nov 2023 23:48:19 +0300

telegram-desktop (4.10.3+ds-2) unstable; urgency=medium

  * Rebuild against cppgir (>= 0~git20231019) to fix null pointer dereference
    in the spellchecker. (Closes: #1053766).

 -- Nicholas Guriev <guriev-ns@ya.ru>  Sat, 21 Oct 2023 23:23:21 +0300

=== debian/control ===
Source: telegram-desktop
Section: net
Priority: optional
Maintainer: Nicholas Guriev <guriev-ns@ya.ru>
Build-Depends: debhelper-compat (=13)
Build-Depends-Arch:
 cmake (>=3.16.0),
 cppgir (>=2.0-2~),
 gobject-introspection,
 libasound2-dev,
 libavcodec-dev (>=7:3.2),
 libavfilter-dev (>=7:3.2),
 libavformat-dev (>=7:3.2),
 libavutil-dev (>=7:3.2),
 libboost-regex-dev,
 libexpected-dev,
 libgirepository1.0-dev,
 libglib2.0-dev (>=2.40.0),
 libglibmm-2.68-dev (>=2.77.0),
 libhunspell-dev,
 libjpeg-dev,
 libkf5coreaddons-dev,
 liblz4-dev,
 libminizip-dev (>=1.1),
 libmsgsl-dev (>=4.0.0-3~),
 libopenal-dev,
 libopus-dev (>=1.1),
 libpulse-dev,
 libqrcodegencpp-dev,
 libqt5svg5-dev,
 libqt5waylandcompositor5-dev,
 librange-v3-dev (>=0.10.0),
 librlottie-dev,
 libssl-dev (>=1.0.1),
 libswresample-dev (>=7:3.2),
 libswscale-dev (>=7:3.2),
 libtgowt-dev (>=0~git20230105),
 libxcb-keysyms1-dev,
 libxcb-record0-dev,
 libxcb-screensaver0-dev,
 libxcb1-dev,
 libxxhash-dev,
 node-prismjs,
 node-types-lodash.isequal,
 nodejs,
 pkg-config,
 python3:any,
 qtbase5-dev (>=5.15.2),
 qtbase5-private-dev (>=5.15.2),
 qtdeclarative5-dev (>=5.15.2),
 zlib1g-dev (>=1:1.2.8),
Build-Conflicts-Arch: libtgvoip-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://desktop.telegram.org
Vcs-Git: https://salsa.debian.org/debian/telegram-desktop.git
Vcs-Browser: https://salsa.debian.org/debian/telegram-desktop

Package: telegram-desktop
# Only little endian is supported.
Architecture: amd64 arm64 armel armhf hurd-amd64 hurd-i386 i386 ia64 loong64 mips64el ppc64el riscv64 sh4 x32
Depends: qt5-image-formats-plugins, ${misc:Depends}, ${shlibs:Depends}
Recommends:
 fonts-open-sans,
 libwebkitgtk-6.0-4 | libwebkit2gtk-4.1-0 | libwebkit2gtk-4.0-37,
Built-Using: ${cpplibs:Built-Using}
Description: fast and secure messaging application
 Telegram is a messaging app with a focus on speed and security, it is
 super-fast, simple and free. You can use Telegram on all your devices at the
 same time — your messages sync seamlessly across any number of your phones,
 tablets or computers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
include /usr/share/dpkg/default.mk

EXTRA_CMAKE_VARIABLES += \
	TDESKTOP_API_ID=50322 \
	TDESKTOP_API_HASH=9ff1a639196c0779c86dd661af8522ba \
	QT_VERSION_MAJOR=5 \
	DESKTOP_APP_DISABLE_SCUDO=ON \
	DESKTOP_APP_USE_PACKAGED_FONTS=ON \
	DESKTOP_APP_USE_PACKAGED_RLOTTIE=ON \
	DESKTOP_APP_USE_PACKED_RESOURCES=ON \
	DESKTOP_APP_USE_CLD3=OFF \
	CMAKE_STATIC_LINKER_FLAGS='-T'

DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Reveal any errors with pre-compiled headers.
DEB_CPPFLAGS_MAINT_APPEND += -Werror=invalid-pch

# Print full stack trace of template instantiations.
DEB_CXXFLAGS_MAINT_APPEND += -ftemplate-backtrace-limit=0

# Build scripts do not require compiled object code. This also shrinks result
# binary by 50 kB.
DEB_CFLAGS_MAINT_STRIP += -ffat-lto-objects
DEB_CXXFLAGS_MAINT_STRIP += -ffat-lto-objects

ifeq ($(filter terse,$(DEB_BUILD_OPTIONS)),)
 # Print entire arguments of moc invocation.
 EXTRA_CMAKE_VARIABLES += CMAKE_AUTOGEN_VERBOSE=ON
endif

ifeq ($(filter pkg.$(DEB_SOURCE).lotmem,$(DEB_BUILD_PROFILES)),)
 ifeq ($(DEB_BUILD_ARCH_BITS),32)
  ATTEMPT_SAVE_MEMORY = 1
  SPLIT_DEBUG_INFO = 1
 endif
endif
ifdef ATTEMPT_SAVE_MEMORY
 # Less debug info by default to fit small address space.
 ifneq ($(filter -g,$(CFLAGS)),)
  DEB_CLAGS_MAINT_STRIP += -g
  DEB_CFLAGS_MAINT_PREPEND += -g1
 endif
 ifneq ($(filter -g,$(CXXFLAGS)),)
  DEB_CXXFLAGS_MAINT_STRIP += -g
  DEB_CXXFLAGS_MAINT_PREPEND += -g1
 endif
 # Attempt to reduce RAM consumption even more.
 DEB_LDFLAGS_MAINT_APPEND += -Wl,--no-keep-memory
endif
ifdef SPLIT_DEBUG_INFO
 DEB_CFLAGS_MAINT_PREPEND += -gsplit-dwarf
 DEB_CXXFLAGS_MAINT_PREPEND += -gsplit-dwarf
endif

ifeq ($(filter pkg.$(DEB_SOURCE).hugeopt,$(DEB_BUILD_PROFILES)),)
 ifeq ($(DEB_VENDOR),Ubuntu)
  # Link time optimizations require more than 8 GB of RAM.
  DEB_BUILD_MAINT_OPTIONS += optimize=-lto
 endif
endif

CPPLIBS_PACKAGES = cppgir libexpected-dev libmsgsl-dev librange-v3-dev libtgowt-dev node-prismjs
EXTRA_SUBSTVARS += \
	cpplibs:Built-Using=$(shell dpkg-query -Wf '$${source:Package}(=$${source:Version}),' $(CPPLIBS_PACKAGES))

# Make visible all possible maintainer's flags.
export DEB_BUILD_MAINT_OPTIONS $(foreach flag,$(DPKG_BUILDFLAGS_LIST),\
	$(foreach operation,STRIP APPEND PREPEND,DEB_$(flag)_MAINT_$(operation)))

# Make debugging a little easier. https://stackoverflow.com/a/25817631/5000805
# Print also export line if the variable is being exported.
print-%:
	@echo $* = $($*)
	@env | sed '/^\($*\)=.*/s//export \1/;t;d'

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CMAKE_VARIABLES:%=-D%)

# Unset limit of debug information entries.
override_dh_dwz:
ifndef SPLIT_DEBUG_INFO
	dh_dwz -- -L none
else

# dwz(1) can't work with split DWARF, see: https://sourceware.org/bugzilla/show_bug.cgi?id=24756
# Gather debug references on my own before Debhelper moves it to -dbgsym package.
TELEGRAM_BINARY = debian/telegram-desktop/usr/bin/telegram-desktop
DBGSYM = debian/.debhelper/telegram-desktop/dbgsym-root
DBGDIR = usr/lib/debug/telegram-desktop
TRACING = $(if $(filter terse,$(DEB_BUILD_OPTIONS)),,-x)
execute_before_dh_strip:
	mkdir -p debian/tmp $(DBGSYM)/$(DBGDIR)
	TMPDIR=debian/tmp debian/dbgpatch.py $(TRACING) $(TELEGRAM_BINARY) $(DBGSYM) $(DBGDIR)
endif

override_dh_gencontrol:
	dh_gencontrol -- $(EXTRA_SUBSTVARS:%="-V%")
